org.sunflow.core.shader

## Class ShinyDiffuseShader

- java.lang.Object
- - org.sunflow.core.shader.ShinyDiffuseShader

All Implemented Interfaces:
  RenderObject, Shader

Direct Known Subclasses:
  TexturedShinyDiffuseShader

    public class ShinyDiffuseShader
    extends java.lang.Object
    implements Shader

### Constructor Summary

Constructors
Constructor and Description
`ShinyDiffuseShader()`

### Method Summary

Methods
`Color` `getDiffuse(ShadingState state)`
`Color` `getOpacity(ShadingState state)` Returns how much light is blocked by this shader.
`Color` `getRadiance(ShadingState state)` Gets the radiance for a specified rendering state.
`protected float` `getShininess()`
`boolean` `isOpaque()` Returns `true` if this shader is fully opaque.
`void` `scatterPhoton(ShadingState state, Color power)` Scatter a photon with the specied power.
`boolean` `update(ParameterList pl, SunflowAPI api)` Update this object given a list of parameters.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ShinyDiffuseShader

    public ShinyDiffuseShader()

### Method Detail

#### update

    public boolean update(ParameterList pl,
                 SunflowAPI api)

Description copied from interface: `RenderObject`
Update this object given a list of parameters. This method is guarenteed to be called at least once on every object, but it should correctly handle empty parameter lists. This means that the object should be in a valid state from the time it is constructed. This method should also return true or false depending on whether the update was succesfull or not.

Specified by:
  `update` in interface `RenderObject`
Parameters:
  `pl` - list of parameters to read from
  `api` - reference to the current scene
Returns:
  `true` if the update is succesfull, `false` otherwise

#### getShininess

    protected float getShininess()

#### getDiffuse

    public Color getDiffuse(ShadingState state)

#### getRadiance

    public Color getRadiance(ShadingState state)

Description copied from interface: `Shader`
Gets the radiance for a specified rendering state. When this method is called, you can assume that a hit has been registered in the state and that the hit surface information has been computed.

Specified by:
  `getRadiance` in interface `Shader`
Parameters:
  `state` - current render state
Returns:
  color emitted or reflected by the shader

#### scatterPhoton

    public void scatterPhoton(ShadingState state,
                     Color power)

Description copied from interface: `Shader`
Scatter a photon with the specied power. Incoming photon direction is specified by the ray attached to the current render state. This method can safely do nothing if photon scattering is not supported or relevant for the shader type.

Specified by:
  `scatterPhoton` in interface `Shader`
Parameters:
  `state` - current state
  `power` - power of the incoming photon.

#### isOpaque

    public boolean isOpaque()

Description copied from interface: `Shader`
Returns `true` if this shader is fully opaque. This gives a quick way to find out if a shader needs further processing when hit by a shadow ray.

Specified by:
  `isOpaque` in interface `Shader`

#### getOpacity

    public Color getOpacity(ShadingState state)

Description copied from interface: `Shader`
Returns how much light is blocked by this shader.

Specified by:
  `getOpacity` in interface `Shader`